<?php
/*************************************************************************************/
/*                                                                                   */
/*      Thelia	                                                            		 */
/*                                                                                   */
/*      Copyright (c) Octolys Development		                                     */
/*		email : thelia@octolys.fr		        	                             	 */
/*      web : http://www.octolys.fr						   							 */
/*                                                                                   */
/*      This program is free software; you can redistribute it and/or modify         */
/*      it under the terms of the GNU General Public License as published by         */
/*      the Free Software Foundation; either version 2 of the License, or            */
/*      (at your option) any later version.                                          */
/*                                                                                   */
/*      This program is distributed in the hope that it will be useful,              */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of               */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                */
/*      GNU General Public License for more details.                                 */
/*                                                                                   */
/*      You should have received a copy of the GNU General Public License            */
/*      along with this program; if not, write to the Free Software                  */
/*      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA    */
/*                                                                                   */
/*************************************************************************************/
?>
<?php

	include_once(realpath(dirname(__FILE__)) . "/../../../fonctions/authplugins.php");

	autorisation("Relaycolis");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/PluginsTransports.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Modules.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Commande.class.php");
	
	
	require_once('lib/nusoap.php');
	
	class Relaycolis extends PluginsTransports{

        var $id;
        var $commande;
        var $point;
        var $nom;
        var $adresse1;
        var $adresse2;
        var $adresse3;
        var $cpostal;
        var $ville;
        var $client;
        var $expedition;

        var $table="RelayColis_commande";
        var $bddvars = array("id", "commande",  "point", "nom", "adresse1", "adresse2", "adresse3", "cpostal", "ville", "client", "expedition");


		function Relaycolis(){
			$this->PluginsTransports("Relaycolis");
		}
		
		function init(){
			$this->ajout_desc("Relaycolis", "Relaycolis", "", 1);

			$cnx = new Cnx();
			$query = "CREATE TABLE `RelayColis_commande` (
          	   	`id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
         	    `commande` INT NOT NULL ,
         	    `point` TEXT NOT NULL ,
         	    `nom` TEXT NOT NULL ,
         	    `adresse1` TEXT NOT NULL ,
         	    `adresse2` TEXT NOT NULL,
         	    `adresse3` TEXT NOT NULL,
         	    `cpostal` TEXT NOT NULL,
         	    `ville` TEXT NOT NULL,
         	    `client`	INT NOT NULL,   
         	    `expedition` INT NOT NULL 	    
         	    )";
         	    
			$resul = mysql_query($query, $cnx->link);						
		}		
		
		function calcule(){
			if($this->poids < 0.50)	return 4.20;
			if($this->poids < 1)	return 4.80;
			if($this->poids < 2)	return 5.50;
			if($this->poids < 3)	return 6.20;
			if($this->poids < 5)	return 7.50;
			if($this->poids < 7)	return 9.60;
			if($this->poids < 10)	return 11.95;
			if($this->poids < 15)	return 14.35;
			if($this->poids < 20)	return 17.95;
		}
               
		function charger($commande){
            return $this->getVars("select * from $this->table where commande=\"$commande\"");
		}
		
		/****************************************************************************/
        /* FONCTION ACTION */
        /****************************************************************************/
        function action(){
        		
        	if($_GET["action"] == "transport")
        	{        	
				$mod = new Modules();
				$mod->charger_id($_GET["id"]);
				if($mod->nom == "Relaycolis")
				{
					?><script type="text/javascript">
						location="Relaycolis.php";
						</script>
					<?php
				}				
			}
			
			if($_GET["action"] == "paiment")
			{
				if(isset($_POST["num_relay"]))
				{
					$_SESSION["num_point_relay"] = $_POST["num_relay"];
				}
			}
			
        
        }
        
        /****************************************************************************/
        /* FONCTION APRES COMMANDE */
        /****************************************************************************/
        
        function aprescommande($commande){
		
			$modules = new Modules();
			$modules->charger("Relaycolis");
		
			if($commande->transport == $modules->id)
			{
				$this->point = $_SESSION["num_point_relay"];
				
				if($_SESSION['navig']->client->raison == 1) $exp_raison = "Mlle";
				if($_SESSION['navig']->client->raison == 2) $exp_raison = "Mme";
				if($_SESSION['navig']->client->raison == 3) $exp_raison = "Mr";
				
				$this->nom =  $exp_raison ." ". $_SESSION["navig"]->client->nom ." ". $_SESSION["navig"]->client->prenom;
				$this->client = $_SESSION['navig']->client->id;
				$this->adresse1 = $_SESSION['navig']->client->adresse2;
				$this->adresse2 = $_SESSION['navig']->client->adresse1;
				$this->adresse3 = $_SESSION['navig']->client->adresse3;
				$this->cpostal = $_SESSION['navig']->client->cpostal;
				$this->ville = $_SESSION['navig']->client->ville;
								
				$commandeRelay = new Commande();
				$query = mysql_query("select * from $commandeRelay->table order by id DESC limit 0,1");
				$row = mysql_fetch_object($query);
				$query = mysql_query("insert into $this->table values (NULL,'$row->id','$this->point','$this->nom','$this->adresse1','$this->adresse2','$this->adresse3','$this->cpostal','$this->ville', '$row->client', 0)");
			}
		}
		
		/****************************************************************************/
        /* FONCTION EXISTE */
        /****************************************************************************/

		
		function existe($id_commande)
		{
			$query = mysql_query("select * from $this->table where commande=\"$id_commande\" ");
			if(mysql_num_rows($query) > 0)
				return true;
			else
				return false;
		}
        
        
        /****************************************************************************/
        /* FONCTION BOUCLE */
        /****************************************************************************/
        
       	function boucle ($texte, $args)
		{
		
			$name = lireTag ($args,"nom");
			$pattern = $texte;
			if ($name == "RelayColis")
			{
				include(realpath(dirname(__FILE__)) . "/config.php");
				
				
					//VARIABLES
				
				$enseigne = $code_enseigne;
				$pays = "FR";
				$ville = $_SESSION["navig"]->client->ville;
				$cp = $_SESSION["navig"]->client->cpostal;
				$taille = "";
				$poids = $this->poids;
				$action = "";
				$mdp = $cle_privee;
		
				$PR = $this->WSI2_rechercheRelay($enseigne, $pays, $ville, $cp, $taille, $poids, $action, $mdp);
				//print_r($PR);
				for ($nbaffiche=1;$nbaffiche<4;$nbaffiche++) 
				{
					$num_p = $PR['PR0'.$nbaffiche]['Num'];
					$nom = $PR['PR0'.$nbaffiche]['LgAdr1'];
					$cp = $PR['PR0'.$nbaffiche]['CP'];
					$adresse1 = $PR['PR0'.$nbaffiche]['LgAdr1'];
					$adresse2 = $PR['PR0'.$nbaffiche]['LgAdr2'];
					$adresse3 = $PR['PR0'.$nbaffiche]['LgAdr3'];
					$ville = $PR['PR0'.$nbaffiche]['Ville'];
					$pays = $PR['PR0'.$nbaffiche]['Pays'];
					$crc = md5("<".$enseigne.$code_marque.">".$num_p.$pays."<".$mdp.">");
					$detailpr = "http://www.mondialrelay.com/lg_fr/espaces/url/popup_pointrelais.aspx?ens=".$enseigne.$code_marque."&num=".
					$num_p."&pays=".$pays."&crc=".$crc ;
						
					$texte = str_replace("NUM", $num_p, $texte);
					$texte = str_replace("VILLE", $ville, $texte);
					$texte = str_replace("NOM", $nom, $texte);
					$texte = str_replace("CP", $cp, $texte);
					$texte = str_replace("ADRESSE1", $adresse1, $texte);
					$texte = str_replace("ADRESSE2", $adresse2, $texte);
					$texte = str_replace("ADRESSE3", $adresse3, $texte);
					$texte = str_replace("DETAILPR", $detailpr, $texte);
						
					if ($nbaffiche != 3) $texte .= $pattern;
				}
							
			} 		
			return $texte;
		}
				
			
		
		/****************************************************************************/
        /* FONCTION POUR CHERCHER POINT RELAY */
        /****************************************************************************/
		
		function WSI2_rechercheRelay($enseigne, $pays, $ville, $cp, $taille, $poids, $action, $mdp)
		{
			require_once('lib/nusoap.php');
			include(realpath(dirname(__FILE__)) . "/config.php");
				
				//CRATION CLIENT
			$client = new nusoap_client("http://www.mondialrelay.fr/WebService/Web_Services.asmx?WSDL", true);
			$client->soap_defencoding = 'utf-8';
				
				//VARIABLES
			$marque = $code_enseigne. $code_marque;
			$params = array(
				'Enseigne' => $enseigne,
				'Pays' => $pays,
				'Ville' => $ville,
				'CP' => $cp,
				'Taille' => $taille,
				'Poids' => $poids,
				'Action' => $action,
				'Security' => strtoupper(md5($enseigne . $pays . $ville . $cp . $taille . $poids . $action . $mdp))
			);
				
				// APPEL WEB-SERVICE VIA SOAP
			$result = $client->call('WSI2_RecherchePointRelais', $params, 'http://www.mondialrelay.fr/webservice/',
			'http://www.mondialrelay.fr/webservice/WSI2_RecherchePointRelais');
				
			$PR = $result['WSI2_RecherchePointRelaisResult'];
				
			return $PR;
		}
	
		/****************************************************************************/
        /* FONCTION POUR RCUPERER L'ETIQUETTE */
        /****************************************************************************/
		
		function WSI2_getEtiquettes($enseigne, $expeditions, $langue)
		{
			$client = new nusoap_client("http://www.mondialrelay.fr/WebService/Web_Services.asmx?WSDL", true);
			$client->soap_defencoding = 'utf-8';
			$mdp = "TesT_MondiaL_RelaY";
			$params = array(
			'Enseigne' => $enseigne,
			'Expeditions' => $expeditions,
			'Langue' => $langue,
			'Security' => strtoupper(md5($enseigne . $expeditions . $langue . $mdp))
			);
			$result = $client->call('WSI2_GetEtiquettes', $params, 'http://www.mondialrelay.fr/webservice/',
			'http://www.mondialrelay.fr/webservice/WSI2_GetEtiquettes');
			
			if ($client->fault)
			{
				//echo '<h2>Fault (Expect - The request contains an invalid SOAP body)</h2><pre>';
				//print_r($result);
				//echo '</pre>';
			} else
			{
				$err = $client->getError();
				if ($err) { echo '<h2>Error</h2><pre>' . $err . '</pre>'; }
				else
				{
					return $result['WSI2_GetEtiquettesResult']['URL_PDF_A5'];
					
				}
			} 
			
			//echo '<h2>Request</h2><pre>' .
			//htmlspecialchars($client->request, ENT_QUOTES) .
			//'</pre>';
			//echo '<h2>Response</h2><pre>' . htmlspecialchars($client->response, ENT_QUOTES) . '</pre>';
			//echo '<h2>Debug</h2><pre>' . htmlspecialchars($client->getDebug(), ENT_QUOTES) . '</pre>';
		}
		
		
}
	
?>
